var document = globalThis.document;
var window  =globalThis
var scr = "#rootPlayer";
const types = {
    isInvisibleWidget: true,
    type: "SCREEN_SETTINGS_WIDGET",
    icon: "icon-screen",
    title: "屏幕高级设置",
    version: "1.1.0",
    isGlobalWidget: true,
    properties: [{key:"a",label:"显示动效",valueType:"boolean",defaultValue:false},{key:"b",label:"动效显示时间(毫秒)",valueType:"number",defaultValue:400}],
    methods: [{key:"setprops",label:"设置",params:[{key:"rotatea",label:"3D旋转中X方向旋转矢量(%)",valueType:"number",defaultValue:0},{key:"rotateb",label:"3D旋转中Y方向旋转矢量(%)",valueType:"number",defaultValue:0},{key:"rotatec",label:"3D旋转中Z方向旋转矢量(%)",valueType:"number",defaultValue:0},
    {key:"rotate",label:"3D旋转中旋转角度",valueType:"number",defaultValue:0},{key:"rotated",
label:"2D旋转角度",valueType:"number",
defaultValue:90},{key:"scalea",label:"X轴放大的倍数",valueType:"number",defaultValue:1},{key:"scaleb",label:"Y轴放大的倍数",valueType:"number",defaultValue:1},{key:"scalec",label:"Z轴放大的倍数",valueType:"number",defaultValue:1},{key:"skewX",label:"X拉伸",valueType:"number",defaultValue:0},{key:"skewY",label:"Y拉伸",valueType:"number",defaultValue:0}],blockOptions:{inputsInline:false}},
 
   {
    key:"Inner",
    label:"获取屏幕内部宽高(中间用逗号隔开)",
    valueType:"string",
    params:[]
   },{
    key:"scrollbar",
    label:"显示滚动条",
    params:[
        {
            key:"t",
            label:"",
            valueType:"boolean",
            defaultValue:true
        }
    ]
   },{
    key:"scrollbarColor",
    label:"设置屏幕滚动条",
    params:[

        {
            key:"t",
            label:"滑块颜色",
            valueType:"color",
            defaultValue:"#666666"
        },{
            key:"b",
            label:"滑块圆角",
            valueType:"number",
            defaultValue:2
        },{
            key:"w",
            label:"滚动条水平宽度",
            valueType:"number",
            defaultValue:5
        },{
            key:"h",
            label:"滚动条竖直高度",
            valueType:"number",
            defaultValue:6
        },{
            key:"track",
            label:"滑动轨道色",
            valueType:"color",
            defaultValue:"#ffffff"
        },{
            key:"trackb",
            label:"轨道圆角",
            valueType:"number",
            defaultValue:2
        }
    ],
    blockOptions:{
        inputsInline:false
    }
   },{
    key:"Dialog",
    label:"设置对话框",
    params:[{
        key:"b",
            label:"确认按钮颜色",
            valueType:"color",
            defaultValue:"#0000ff"
    },{
        key:"c",
        label:"按住按钮时按钮色",
        valueType:"color",
        defaultValue:"#0000ff"
    }]
   },{
    key:"Button",
    label:"设置按钮",
    tooltip:`有人想做类似win10UI,但按钮都是圆角的,所以创建本方法`,
    params:[{
        key:"br",
        label:"圆角",
        valueType:"number",
        defaultValue:10
    }]
   }
],
    events: [],
};

class Widget extends InvisibleWidget {
    transform
    constructor(props) {
        super(props);
        this.a = props.a;
        this.b = props.b/1000;
    }
    
    setprops(rotatea,rotateb,rotatec,rotate,rotated,scalea,scaleb,scalec,skewX,skewY,X,Y){
        if(scalea === 0||scalea === NaN){this.widgetError("放大X值无效")}
        if(Number(skewX) === NaN||Number(skewY) === NaN){this.widgetError("拉伸值无效")}
        this.transform = `rotate3d(${rotatea/100},${rotateb/100},${rotatec/100},${rotate}deg) rotate(${rotated}deg) scale3d(${scalea},${scaleb},${scalec}) skew(${skewX}deg,${skewY}deg) translate(${X}px,${Y}px)`;
        document.documentElement.style.transform = this.transform;
    }

    get a(){
        return document.documentElement.style.transition.includes("transform")?true:false
    }

    set a(e = false){
      if(e){
        document.documentElement.style.transition = `transform ${this.b}s ease-in-out`
      }else{
        document.documentElement.style.transition = "none"
      }
    }
    

    setWH(w,h){
        document.querySelector(scr).style.width = w+"px";
        document.querySelector(scr).style.height = h+"px";
    }

    Inner(){
        return [globalThis.innerWidth,globalThis.innerHeight].toString()
    }
    
    scrollbar(t){
       document.querySelector(".screen-view-inner").style.overflow = t?'scroll':'hidden'
    }

    scrollbarColor(t,b,w,h,track,trackb,arrow){

         const csscode = `<style>
         .screen-view-inner::-webkit-scrollbar{
            width:${w}px;
            height:${h}px
         }
         .screen-view-inner::-webkit-scrollbar-thumb{
            background-color:${t};
            border-radius:${b}px;
         }
         .screen-view-inner::-webkit-scrollbar-track{
            background-color:${track};
            border-radius:${trackb}px;
         }
         
         </style>`
         document.head.innerHTML += csscode
         
    }

    Dialog(b,c){
        const css= `
        *{
            --dialog-theme-color:${b};
            --dialog-theme-color-dark:${c}
        }
        `;
        document.head.innerHTML += "<style>"+css+"</style>"
    }

    Button(br){
        setInterval(b =>{
            if(document.querySelectorAll(`button[data-widget-type="NEW_BUTTON_WIDGET"]`)[0]){
                document.querySelectorAll(`button[data-widget-type="NEW_BUTTON_WIDGET"]`).forEach(value =>{
                    value.style.borderRadius = br+"px"
                })
            }
        },50)
    }

    


}

types["methods"][0]["params"].push({
    key:'X',
    label:"平移X坐标值",
    valueType:"number",
    defaultValue:0
})

types["methods"][0]["params"].push({
    key:'Y',
    label:"平移Y坐标值",
    valueType:"number",
    defaultValue:0
})

types["methods"].push({
    key:"setWH",
    label:"设置屏幕宽高(像素)",
    params:[{
        key:"w",label:"宽",valueType:'number',defaultValue:360
    },{key:"h",label:"高",valueType:"number",defaultValue:640}]
})

types["properties"].push({
    key:"cau",
    label:"注意",
    valueType:"string",
    editorType:"TextArea",
    defaultValue:`Q:1.滚动条自定义后无法显示？\nA:可能是:a.未显示滚动条;b.没有控件显示到屏幕以外的地方;`
})


exports.types = types;
exports.widget = Widget;

